Metadata-Version: 2.4
Name: apimatic-ak-sdk
Version: 0.0.1
Summary: Test APIs from APIMatic to demonstrate the SDKs
Author-email: developer sdksio <developer+sdksio@apimatic.io>
Project-URL: Documentation, https://apimatic.io
Keywords: Apimatic,sdkio
Requires-Python: >=3.7
Description-Content-Type: text/markdown
License-File: LICENSE
Requires-Dist: apimatic-core>=0.2.24,~=0.2.0
Requires-Dist: apimatic-core-interfaces>=0.1.8,~=0.1.0
Requires-Dist: apimatic-requests-client-adapter>=0.1.10,~=0.1.0
Requires-Dist: python-dotenv<2.0,>=0.21
Provides-Extra: testutils
Requires-Dist: pytest>=7.2.2; extra == "testutils"
Dynamic: license-file


# Getting Started with Akoya

## Introduction

Akoya product APIs for data access. Default servers are set for the Akoya sandbox environment.

Akoya APIs include the following updates:

- v2.2.2
  - Added mode query parameter to Account Information, Balances, Investments, and Transactions to support standard mode.
  - Edited callouts for Account Holder endpoint
- v2.2.1
  - Fixed typo in `accountIds` query parameter for `/accounts-info`, `/balances`, `/accounts`
  - Added security method for `Account holder information` to bear token. Missing method defaulted to basic auth.
  - Added examples and descriptions to some schemas
  - Added HTTP status `429` FDX error `1207`.
- v2.2 Additions
  - Added optional `x-akoya-interaction-type` header to all endpoints to specify if a request is part of a batch process
  - Update of tags to organize endpoints by Akoya product
  - `206` response added to `/accounts-info`, `/balances`, `/accounts`
- v2.1 New Statements product and Customers product updated with additional endpoint, `Account holder information`.
- v2.0 Launch of Akoya products: Account Info, Balances, Investments, Transactions, Payments, Customers.

## Install the Package

The package is compatible with Python versions `3.7+`.
Install the package from PyPi using the following pip command:

```bash
pip install apimatic-ak-sdk==0.0.1
```

You can also view the package at:
https://pypi.python.org/pypi/apimatic-ak-sdk/0.0.1

## Initialize the API Client

**_Note:_** Documentation for the client can be found [here.](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/client.md)

The following parameters are configurable for the API Client:

| Parameter | Type | Description |
|  --- | --- | --- |
| environment | [`Environment`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/README.md#environments) | The API environment. 
 **Default: `Environment.PRODUCTION`** |
| http_client_instance | `Union[Session, HttpClientProvider]` | The Http Client passed from the sdk user for making requests |
| override_http_client_configuration | `bool` | The value which determines to override properties of the passed Http Client from the sdk user |
| http_call_back | `HttpCallBack` | The callback value that is invoked before and after an HTTP call is made to an endpoint |
| timeout | `float` | The value to use for connection timeout. 
 **Default: 60** |
| max_retries | `int` | The number of times to retry an endpoint call if it fails. 
 **Default: 0** |
| backoff_factor | `float` | A backoff factor to apply between attempts after the second try. 
 **Default: 2** |
| retry_statuses | `Array of int` | The http statuses on which retry is to be done. 
 **Default: [408, 413, 429, 500, 502, 503, 504, 521, 522, 524]** |
| retry_methods | `Array of string` | The http methods on which retry is to be done. 
 **Default: ["GET", "PUT"]** |
| proxy_settings | [`ProxySettings`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/proxy-settings.md) | Optional proxy configuration to route HTTP requests through a proxy server. |
| logging_configuration | [`LoggingConfiguration`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/logging-configuration.md) | The SDK logging configuration for API calls |
| basic_auth_credentials | [`BasicAuthCredentials`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/auth/basic-authentication.md) | The credential object for Basic Authentication |
| bearer_auth_credentials | [`BearerAuthCredentials`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/auth/oauth-2-bearer-token.md) | The credential object for OAuth 2 Bearer token |

The API client can be initialized as follows:

### Code-Based Client Initialization

```python
import logging

from akoya.akoya_client import AkoyaClient
from akoya.configuration import Environment
from akoya.http.auth.basic_auth import BasicAuthCredentials
from akoya.http.auth.bearer_auth import BearerAuthCredentials
from akoya.logging.configuration.api_logging_configuration import LoggingConfiguration
from akoya.logging.configuration.api_logging_configuration import RequestLoggingConfiguration
from akoya.logging.configuration.api_logging_configuration import ResponseLoggingConfiguration

client = AkoyaClient(
    basic_auth_credentials=BasicAuthCredentials(
        username='Username',
        password='Password'
    ),
    bearer_auth_credentials=BearerAuthCredentials(
        access_token='AccessToken'
    ),
    environment=Environment.PRODUCTION,
    logging_configuration=LoggingConfiguration(
        log_level=logging.INFO,
        request_logging_config=RequestLoggingConfiguration(
            log_body=True
        ),
        response_logging_config=ResponseLoggingConfiguration(
            log_headers=True
        )
    )
)
```

### Environment-Based Client Initialization

```python
from akoya.akoya_client import AkoyaClient

# Specify the path to your .env file if it’s located outside the project’s root directory.
client = AkoyaClient.from_environment(dotenv_path='/path/to/.env')
```

See the [Environment-Based Client Initialization](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/environment-based-client-initialization.md) section for details.

## Environments

The SDK can be configured to use a different environment for making API calls. Available environments are:

### Fields

| Name | Description |
|  --- | --- |
| PRODUCTION | **Default** Sandbox server |
| ENVIRONMENT2 | Products server |

## Authorization

This API uses the following authentication schemes.

* [`basicAuth (Basic Authentication)`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/auth/basic-authentication.md)
* [`bearerAuth (OAuth 2 Bearer token)`](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/auth/oauth-2-bearer-token.md)

## List of APIs

* [Accountinformation](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/accountinformation.md)
* [Balances](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/balances.md)
* [Customers](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/customers.md)
* [Investments](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/investments.md)
* [Payments](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/payments.md)
* [Statements](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/statements.md)
* [Transactions](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/transactions.md)
* [Tokens](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/controllers/tokens.md)

## SDK Infrastructure

### Configuration

* [ProxySettings](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/proxy-settings.md)
* [Environment-Based Client Initialization](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/environment-based-client-initialization.md)
* [AbstractLogger](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/abstract-logger.md)
* [LoggingConfiguration](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/logging-configuration.md)
* [RequestLoggingConfiguration](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/request-logging-configuration.md)
* [ResponseLoggingConfiguration](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/response-logging-configuration.md)

### HTTP

* [HttpResponse](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/http-response.md)
* [HttpRequest](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/http-request.md)

### Utilities

* [ApiResponse](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/api-response.md)
* [ApiHelper](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/api-helper.md)
* [HttpDateTime](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/http-date-time.md)
* [RFC3339DateTime](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/rfc3339-date-time.md)
* [UnixDateTime](https://www.github.com/sdks-io/apimatic-ak-python-sdk/tree/0.0.1/doc/unix-date-time.md)

